var tut =
{
    /**
     * Hace que un elemento "parpadee" por una combinación de 1.4 segundos
     *
     * @public
     * @param {TimelineMax} timeline Timeline que contendrá la animación (ya creado)
     * @param {selector} target (selector u objeto de js)
     * @param {number} scaleFrom tamaño para escalar desde
     * @param {number} scaleTo tamaño para escalar hasta
     * @param {number} delay a esperar antes de iniciar la animación (si aplica)
     * @returns {Array} Returns `array`.
     */
    flashElement: function flashElement(timeline, target, scaleFrom, scaleTo, delay) {
        timeline
            .to(target, 0.3, {scale: scaleTo, ease: Circ.easeOut, delay: delay})
            .to(target, 0.4, {scale: scaleFrom, ease: Bounce.easeOut})
            .to(target, 0.3, {scale: scaleTo, ease: Circ.easeOut})
            .to(target, 0.4, {scale: scaleFrom, ease: Bounce.easeOut});

        return timeline;
    },
    /**
     * Refresca los StyleSheets
     *
     * @public
     */
    reloadStylesheets: function () {
        var queryString = '?reload=' + new Date().getTime();
        $('link[rel="stylesheet"]').each(function () {
            this.href = this.href.replace(/\?.*|$/, queryString);
        });
    },
    hiddenShadowboxFromProps: function(delay) {
        return {autoAlpha: 0, ease:Power1.easeOut, delay: delay};
    },
    hiddenShadowboxToProps: function(delay) {
        var props = tut.hiddenShadowboxFromProps(delay);
        props.autoAlpha = 1;
        return props;
    },
    rotarHojaFueraProps: function(delay) {
        return {autoAlpha: 0, rotation:-90, transformOrigin:"320px 1400px", ease:Linear.easeNone, delay: delay};
    },
    rotarHojaDentroProps: function(delay) {
        return {autoAlpha: 0, rotation:90, transformOrigin:"320px 1400px", ease:Linear.easeNone, delay: delay};
    },
    aparecerDesdeAbajo: function(delay) {
        return {y: 200, ease:Linear.easeNone, delay: delay};
    },
    flashMasInfoEn1: function() {
        // flashElement(tl_masinfo, "#slider_masinfo1", 1, 1.3);

        var animarMasInfo = true;
        setInterval(function() {
            if( animarMasInfo && tl.progress() == 0 && !(tl_masinfo.isActive()) ) {
                tl_masinfo.resume();
            }
            else tl_masinfo.pause(); tl_masinfo.progress(0);
        }, 1000);

        $("#slider_masinfo1")
            .mouseover( function() {
                animarMasInfo = false;
                TweenLite.to("#" + this.id, 0.4, {scale: 1.5, ease:Bounce.easeOut})
            })
            .mouseleave( function() {
                TweenLite.set("#" + this.id, {clearProps: "all"})
                animarMasInfo = true;
            })
        ;
    }


};