// =================================================================================
// Slider Magic
// =================================================================================
//
// @author: 3f Interactive
// @site: http://3finteractive.net
//
// Wrapper for TimeMax that handles a step-by-step slider
//
// requires jquery-ui
//
// =================================================================================

TweenLite.to($("#slider_pause"), 0, {autoAlpha: 0, scale: 0, ease:Linear.easeOut})  
TweenLite.to($("#slider_sin_sonido"), 0, {autoAlpha: 0, scale: 0, ease:Linear.easeOut}) 

var SliderMagic,
    extend = function(child, parent) {
      for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; }
      function ctor() { this.constructor = child; }
      ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype;
      return child;
    },
    hasProp = {}.hasOwnProperty;

SliderMagic = (function() {

  var IMMEDIATE = -1;

  function SliderMagic(timelineMax) {
    var self = this;
    var onUpdateCallbackList = [];

    //
    // Este metodo actualiza el valor del Slider en funcion del progreso de la animacion,
    //
    SliderMagic.prototype.updateSlider = function(progress) {
      var slider = $(".slider_new");
      var totalWidth = $(".slider_new .progress_background").width();

      var completedWidth = totalWidth * progress;
      if($(".slider_new .item1").length > 0 && completedWidth > $(".slider_new .item1").position().left) slider.addClass("item1"); else slider.removeClass("item1");
      if($(".slider_new .item2").length > 0 && completedWidth > $(".slider_new .item2").position().left) slider.addClass("item2"); else slider.removeClass("item2");
      if($(".slider_new .item3").length > 0 && completedWidth > $(".slider_new .item3").position().left) slider.addClass("item3"); else slider.removeClass("item3");
      if($(".slider_new .item4").length > 0 && completedWidth > $(".slider_new .item4").position().left) slider.addClass("item4"); else slider.removeClass("item4");
      if($(".slider_new .item5").length > 0 && completedWidth > $(".slider_new .item5").position().left) slider.addClass("item5"); else slider.removeClass("item5");
      if($(".slider_new .item6").length > 0 && completedWidth > $(".slider_new .item6").position().left) slider.addClass("item6"); else slider.removeClass("item6");    
      if($(".slider_new .item7").length > 0 && completedWidth > $(".slider_new .item7").position().left) slider.addClass("item7"); else slider.removeClass("item7");
      if($(".slider_new .item8").length > 0 && completedWidth > $(".slider_new .item8").position().left) slider.addClass("item8"); else slider.removeClass("item8");
      if($(".slider_new .item9").length > 0 && completedWidth > $(".slider_new .item9").position().left) slider.addClass("item9"); else slider.removeClass("item9");
      if($(".slider_new .item10").length > 0 && completedWidth > $(".slider_new .item10").position().left) slider.addClass("item10"); else slider.removeClass("item10");
      if($(".slider_new .itemFin").length > 0 && completedWidth > $(".slider_new .itemFin").position().left) slider.addClass("itemFin"); else slider.removeClass("itemFin");
    
      $(".slider_new .progress_position").width( completedWidth );
      $(".slider_new .position").css( "left", completedWidth + "px" );
    }

    // Cambio la posición del Slider
    SliderMagic.prototype.changePosition = function() {
      self.pause( IMMEDIATE );

      var totalWidth = $(".slider_new .progress_background").width();
      var position = $(this).position().left + this.getBoundingClientRect().width / 2 - $(".position").width() / 2;
      var progressPercent = position / totalWidth;
      self.timelineMax.progress(progressPercent);
    }

    SliderMagic.prototype.startDragging = function()  {
      self.pause( IMMEDIATE );
    }

    SliderMagic.prototype.play = function() {
      // perdon, perdon, perdon
      $.magnificPopup.close();
      
      self.timelineMax.resume();
      TweenLite.to(tl, 0.5, { timeScale: 1 });

      TweenLite.to($("#slider_play"), 0.5, {autoAlpha: 0, scale: 0, ease:Bounce.easeOut})
      TweenLite.to($("#slider_pause"), 0.5, {autoAlpha: 1, scale: 1, ease:Bounce.easeOut})
    };

    SliderMagic.prototype.pause = function ( constPredefinedDuration ) {
      var duration = 0.3;
      if (constPredefinedDuration === IMMEDIATE) duration = 0;

      TweenLite.to(self.timelineMax, duration, { timeScale: 0, onComplete: function() { self.timelineMax.pause() }} )
      TweenLite.to($("#slider_pause"), 0.3, {autoAlpha: 0, scale: 0, ease:Bounce.easeOut})
      TweenLite.to($("#slider_play"), 0.3, {autoAlpha: 1, scale: 1, ease:Bounce.easeOut})
    };

    SliderMagic.prototype.soundon = function() {
    //TODO: Como manejamos sonidos en HTMl5?
    
      TweenLite.to($("#slider_sonido"), 0.5, {autoAlpha: 0, scale: 0, ease:Bounce.easeOut})
      TweenLite.to($("#slider_sin_sonido"), 0.5, {autoAlpha: 1, scale: 1, ease:Bounce.easeOut})
    };

    SliderMagic.prototype.soundoff = function() {
    //TODO: Como manejamos sonidos en HTMl5?
  
      TweenLite.to($("#slider_sin_sonido"), 0.5, {autoAlpha: 0, scale: 0, ease:Bounce.easeOut})
      TweenLite.to($("#slider_sonido"), 0.5, {autoAlpha: 1, scale: 1, ease:Bounce.easeOut})
    };

    /**
     * Add a function to be call on onUpdate.
     */
    SliderMagic.prototype.addUpdateCallback = function(callback) {
      onUpdateCallbackList.push(callback);
    }

    /**
     * Function to be call upon onUpdate and calls all the registered callbacks
     */
    SliderMagic.prototype.onUpdate = function() {
      var progress = self.timelineMax.progress();
      onUpdateCallbackList.forEach(function(callback) {
        callback(progress);
      });
    }
  
    // init //

    this.timelineMax = timelineMax;

    this.addUpdateCallback( this.updateSlider );
    this.timelineMax.eventCallback("onUpdate", this.onUpdate);

    // other //

    if (console) console.warn("SliderMagic is working on legacy mode, events'assignment is hard-coded.");
    $("#slider_pause").on( "click", self.pause );
    $("#slider_play").on( "click", self.play );
    $("#slider_sin_sonido").on( "click", self.soundoff );
    $("#slider_sonido").on( "click", self.soundon );  
    $("#comenzar").on( "click", self.play );

    $(".slider_new .item").click(self.changePosition);
    $(".slider_new .position").draggable({ axis: "x", containment: ".slider_new",
      start: self.startDragging,
      stop: self.changePosition,
      drag: self.changePosition
    });
  }

  return SliderMagic;

})();



